Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices
Imports System.drawing
Imports System.Windows.Forms


'//////////////////////////////////////////////////////////////
''' <summary>
''' DirectShowp̃[eBeBW[(Đ֌W)łB
''' </summary>
''' <remarks></remarks>
Public Module DSUtilityPlay

#Region "{"

    ''' <summary>
    ''' OtJn(Đ)܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <remarks></remarks>
    Public Sub GraphPlay(ByVal Grp As IGraphBuilder)

        Try
            'IMediaControlC^[tF[X̎擾
            Dim ctl As IMediaControl = CType(Grp, IMediaControl)

            'ĐJn
            ctl.Run()

        Catch ex As Exception
            Throw New DSException(ex, "ĐɎs܂B")
        End Try

    End Sub

    ''' <summary>
    ''' Ot~܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <remarks></remarks>
    Public Sub GraphStop(ByVal Grp As IGraphBuilder)

        Try
            'IMediaControlC^[tF[X̎擾
            Dim ctl As IMediaControl = CType(Grp, IMediaControl)

            'ĐJn
            ctl.Stop()

        Catch ex As Exception
            Throw New DSException(ex, "~Ɏs܂B")
        End Try

    End Sub

    ''' <summary>
    ''' Otꎞ~܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <remarks></remarks>
    Public Sub GraphPause(ByVal Grp As IGraphBuilder)

        Try
            'IMediaControlC^[tF[X̎擾
            Dim ctl As IMediaControl = CType(Grp, IMediaControl)

            'ĐJn
            ctl.Pause()

        Catch ex As Exception
            Throw New DSException(ex, "ꎞ~Ɏs܂B")
        End Try

    End Sub

#End Region

#Region "[vĐ"

    ''' <summary>
    ''' Ot[vĐJn܂B
    ''' </summary>
    ''' <param name="Grp">Ot</param>
    ''' <param name="Callback">JԂ̃R[obN֐</param>
    ''' <returns>IĎXbh</returns>
    ''' <remarks>
    ''' ʃXbhŃOt̍ĐԂĎAĐI琶ʒu擪Ɉړ܂B
    ''' OtĐԂłȂȂꍇAyсAG[ꍇɊĎI܂B
    ''' </remarks>
    Public Function PlayLoopStart(ByVal Grp As IGraphBuilder, Optional ByVal Callback As DelegatePlayLoop = Nothing) As System.Threading.Thread

        'ĎXbh쐬
        Dim th As System.Threading.Thread
        th = New System.Threading.Thread(AddressOf PlayLoopMain)

        'ĎXbhJn
        Dim pld As New PlayLoopData
        pld.Graph = Grp
        pld.Callback = Callback
        th.Start(pld)

        Return th
    End Function

    ''' <summary>
    ''' Ot̃[vĐI܂B
    ''' </summary>
    ''' <param name="PlayLoopThread">ĎXbh</param>
    ''' <remarks>
    ''' ɂPlayLoopStart̖߂lw肵ĉB
    ''' </remarks>
    Public Sub PlayLoopStop(ByVal PlayLoopThread As System.Threading.Thread)

        If PlayLoopThread IsNot Nothing Then

            '[vĎpXbhÎ҂
            PlayLoopThread.Join()

        End If

    End Sub

    ''' <summary>
    ''' [vĐĎpXbh̃W[łB
    ''' </summary>
    ''' <param name="PLData">Ďpf[^</param>
    ''' <remarks>̃\bh͓płBʏAvP[V͎gp܂B</remarks>
    Private Sub PlayLoopMain(ByVal PLData As Object)

        Try

            '`FbN
            Dim pld As PlayLoopData = TryCast(PLData, PlayLoopData)
            If pld Is Nothing Then Exit Sub
            Dim evt As IMediaEvent = TryCast(pld.Graph, IMediaEvent)
            Dim grp As IGraphBuilder = TryCast(pld.Graph, IGraphBuilder)
            If (evt Is Nothing) Or (grp Is Nothing) Then Exit Sub

            Dim rc As Integer
            Dim ec As Integer
            Do
                'Cxg҂
                rc = evt.WaitForCompletion(1000, ec)
                If rc = DirectShowHRESULT.S_OK Then
                    'Cxg

                    If ec = DirectShowEventCode.EC_COMPLETE Then
                        'Đ

                        '߂
                        Dim pos As IMediaPosition = TryCast(pld.Graph, IMediaPosition)
                        If Not pos Is Nothing Then

                            'Đʒu擪ɕύX
                            pos.put_CurrentPosition(0)

                            'R[obN
                            If Not pld.Callback Is Nothing Then
                                If pld.Callback() Then
                                    'I
                                    Exit Do
                                End If
                            End If

                            'Đp
                            Continue Do
                        End If
                    End If

                    '[vׂłȂCxg
                    'iG[A[U~߂j
                    'ĎI
                    Exit Do
                End If

                'CxgȂꍇĐԂ`FbNA
                'ĐłȂΏIB
                Dim st As FILTER_STATE = GetGraphState(grp)
                If (st = FILTER_STATE.Running) Or (st = FILTER_STATE.BusyToRunning) Then
                    'Đ
                Else
                    Exit Do
                End If
            Loop

        Catch ex As Exception
            'Throw New DSException(ex, "[vĐɎs܂B")
            Debug.Print("[vĐŖ肪܂BȌニ[vĐ͍s܂B")
        End Try

    End Sub

    ''' <summary>
    ''' [vĐĎpf[^NXłB
    ''' </summary>
    ''' <remarks>̃\bh͓płBʏAvP[V͎gp܂B</remarks>
    Private Class PlayLoopData
        ''' <summary>ĎΏۂ̃OtłB</summary>
        Public Graph As IGraphBuilder
        ''' <summary>I[ɒBꍇɌĂяofQ[głBNothing̏ꍇĂяo܂B</summary>
        Public Callback As DelegatePlayLoop
    End Class

    ''' <summary>
    ''' [vĐɏI[ɒBɌĂяofQ[głB
    ''' </summary>
    ''' <returns>[vĐIꍇTrueApꍇFalse</returns>
    ''' <remarks></remarks>
    Public Delegate Function DelegatePlayLoop() As Boolean

#End Region

End Module
