Option Explicit On
Option Strict On

Imports System.Runtime.InteropServices

'//////////////////////////////////////////////////////////////
''' <summary>
''' DirectShowp̃[eBeBW[(fobO֌W)łB
''' </summary>
''' <remarks></remarks>
Public Module DSUtilityDebug

    ''' <summary>
    ''' Ot̓eR\[ɏo͂܂B
    ''' </summary>
    ''' <param name="Graph">Ot</param>
    ''' <remarks></remarks>
    Public Sub DebugPrint(ByVal Graph As IGraphBuilder)

        Try

            'O`FbN
            If Graph Is Nothing Then Exit Sub

            'tB^񋓎q擾
            Dim eflt As IEnumFilters = Nothing
            Graph.EnumFilters(eflt)

            'tB^
            Dim fc As Integer
            Dim flt As IBaseFilter = Nothing
            Do While eflt.Next(1, flt, fc) = 0
                If fc = 0 Then Exit Do

                'tB^̎擾
                Dim finfo As New FILTER_INFO
                Dim fltname As String = "(sȃtB^)"
                If flt.QueryFilterInfo(finfo) = 0 Then
                    fltname = finfo.achName
                    ReleaseInstance(finfo.pUnk)
                End If

                'tB^\
                System.Console.WriteLine("[{0}]", fltname)

                's񋓎q擾
                Dim epin As IEnumPins = Nothing
                flt.EnumPins(epin)

                's
                Dim pc As Integer
                Dim pin As IPin = Nothing
                Do While epin.Next(1, pin, pc) = 0
                    If pc = 0 Then Exit Do

                    's擾
                    Dim pinfo As New PIN_INFO
                    If pin.QueryPinInfo(pinfo) = 0 Then

                        'so
                        System.Console.Write("  '{0}' ", pinfo.Name)
                        Select Case pinfo.PinDir
                            Case DSConst.PIN_DIRECTION.PINDIR_INPUT
                                System.Console.Write(" <== ")
                            Case DSConst.PIN_DIRECTION.PINDIR_OUTPUT
                                System.Console.Write(" ==> ")
                            Case Else
                                System.Console.Write(" ??? ")
                        End Select

                        'ڑ擾
                        Dim cpin As IPin = Nothing
                        Try
                            pin.ConnectedTo(cpin)
                        Catch ex As COMException
                            If ex.ErrorCode = DSConst.DirectShowHRESULT.VFW_E_NOT_CONNECTED Then
                                cpin = Nothing
                            Else
                                Throw New DSException(ex, "ڑ̃s񂪎擾ł܂B")
                            End If
                        End Try
                        If Not cpin Is Nothing Then
                            'ڑς݂̃s

                            'ڑs̏擾
                            Dim cpinfo As New PIN_INFO
                            If cpin.QueryPinInfo(cpinfo) = 0 Then

                                'ڑso
                                System.Console.Write("'{0}'@", cpinfo.Name)

                                'ڑtB^̏擾
                                Dim cfinfo As New FILTER_INFO
                                If cpinfo.Filter.QueryFilterInfo(cfinfo) = 0 Then
                                    ReleaseInstance(finfo.pUnk)
                                    System.Console.Write("[{0}]", cfinfo.achName)
                                Else
                                    System.Console.Write("(sȃtB^)")
                                End If

                                'ڑs񒆂̃tB^
                                If Not cpinfo.Filter Is Nothing Then Marshal.ReleaseComObject(cpinfo.Filter)

                                'ڑs̉
                                Marshal.ReleaseComObject(cpin)
                            Else
                                System.Console.Write("(sȃs)")
                            End If

                        End If

                        System.Console.WriteLine()

                        's񒆂̃tB^
                        If Not pinfo.Filter Is Nothing Then Marshal.ReleaseComObject(pinfo.Filter)
                    End If

                    's
                    Marshal.ReleaseComObject(pin)
                Loop


                'tB^
                Marshal.ReleaseComObject(flt)
            Loop

            'tB^񋓏I
            Marshal.ReleaseComObject(eflt)

        Catch ex As DSException
            Debug.Print("Ot̃fobOo͂Ɏs܂B")
            Debug.Print(ex.FullMessage)

        Catch ex As Exception
            Debug.Print("Ot̃fobOo͂Ɏs܂B")
            Debug.Print(ex.Message)
        End Try

    End Sub

    ''' <summary>
    ''' OtGRFt@Cɕۑ܂B
    ''' GRFt@C̓fobOpɎgpĉB
    ''' </summary>
    ''' <param name="Grp">ۑOt</param>
    ''' <param name="Filename">GRFt@C</param>
    ''' <remarks>sꍇAeOX[܂B</remarks>
    Public Sub SaveGraphFile(ByRef Grp As IGraphBuilder, ByVal Filename As String)
        Dim ps As IPersistStream = Nothing
        Dim grpstr As IStorage = Nothing
        Dim strm As System.Runtime.InteropServices.ComTypes.IStream = Nothing

        Try
            'IPresistStreamC^[tF[X̎擾
            ps = CType(Grp, IPersistStream)

            'IStorageIuWFNg쐬
            Win32API.StgCreateDocfile(Filename, STGM.STGM_CREATE Or STGM.STGM_TRANSACTED Or STGM.STGM_READWRITE Or STGM.STGM_SHARE_EXCLUSIVE, 0, grpstr)

            'Xg[쐬
            grpstr.CreateStream("ActiveMovieGraph", STGM.STGM_WRITE Or STGM.STGM_CREATE Or STGM.STGM_SHARE_EXCLUSIVE, 0, 0, strm)

            'Otۑ
            ps.Save(strm, True)

            't@Cɏo
            grpstr.Commit(0)

        Catch ex As Exception
            's
            Throw New DSException(ex, "GRFt@C̕ۑɎs܂B- {0}", Filename)

        Finally
            'svƂȂIuWFNg̊J

            If Not grpstr Is Nothing Then
                Marshal.ReleaseComObject(grpstr)
                grpstr = Nothing
            End If

            If Not strm Is Nothing Then
                Marshal.ReleaseComObject(strm)
                strm = Nothing
            End If
        End Try

    End Sub

    ''' <summary>
    ''' GRFt@COtǂݍ݂܂B
    ''' </summary>
    ''' <param name="Filename">GRFt@C</param>
    ''' <returns>ǂݍ܂ꂽOt</returns>
    ''' <remarks>sꍇAeOX[܂B</remarks>
    Public Function LoadGraphFile(ByVal Filename As String) As IGraphBuilder

        Dim newgrp As IGraphBuilder = Nothing
        Dim grpstr As IStorage = Nothing
        Dim ps As IPersistStream = Nothing
        Dim strm As System.Runtime.InteropServices.ComTypes.IStream = Nothing
        Try
            'NXhc
            Dim FilterGraphManagerClassID As Guid
            FilterGraphManagerClassID = New Guid(ClassGUID.CLSID_FilterGraph)

            '^Cv̎擾
            Dim FilterGraphManagerType As Type
            FilterGraphManagerType = Type.GetTypeFromCLSID(FilterGraphManagerClassID)

            'tB^Ot}l[W̃CX^X쐬
            Dim FilterGraphManagerObject As Object
            FilterGraphManagerObject = Activator.CreateInstance(FilterGraphManagerType)

            'IGraphBuilderC^[tF[X̎擾
            newgrp = CType(FilterGraphManagerObject, IGraphBuilder)

            '(ʂ)t@Cł邩`FbN
            If Win32API.StgIsStorageFile(Filename) <> 0 Then Return Nothing

            'IStorageIuWFNg쐬
            Win32API.StgOpenStorage(Filename, Nothing, STGM.STGM_TRANSACTED Or STGM.STGM_READ Or STGM.STGM_SHARE_DENY_WRITE, Nothing, 0, grpstr)

            'IPresistStreamC^[tF[X̎擾
            ps = CType(newgrp, IPersistStream)

            'Xg[쐬
            grpstr.OpenStream("ActiveMovieGraph", Nothing, STGM.STGM_READ Or STGM.STGM_SHARE_EXCLUSIVE, 0, strm)

            'Ǎ
            ps.Load(strm)

        Catch ex As Exception
            's

            'Ot̉
            If Not newgrp Is Nothing Then
                Marshal.ReleaseComObject(newgrp)
                newgrp = Nothing
            End If

            Throw New DSException("GRFt@C̓ǍɎs܂B- {0}", Filename)

        Finally
            'svƂȂIuWFNg̊J

            If Not grpstr Is Nothing Then
                Marshal.ReleaseComObject(grpstr)
                grpstr = Nothing
            End If

            If Not ps Is Nothing Then
                Marshal.ReleaseComObject(ps)
                ps = Nothing
            End If

            If Not strm Is Nothing Then
                Marshal.ReleaseComObject(strm)
                strm = Nothing
            End If

        End Try

        Return newgrp
    End Function

End Module
