Option Explicit On
Option Strict On

'//////////////////////////////////////////////////////////////
'DShowLib@Tv@Telop
'EJf̏Ɍݎdˍ킹ĕ\TvłB
'EPictureBoxɕ`悵Î~𓮉̏ɏdˍ킹ĕ\܂B
'Edˍ킹ɂ́uVideo Mixing Renderer 9vgpĂ܂B
'//////////////////////////////////////////////////////////////

'DirectShowNXCu
Imports DShowLib
Public Class Form1

    'API
    Private Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hDC As IntPtr, ByVal x As Integer, ByVal y As Integer, ByVal dx As Integer, ByVal dy As Integer, ByVal SrcX As Integer, ByVal SrcY As Integer, ByVal Scan As Integer, ByVal NumScans As Integer, ByVal Bits As IntPtr, ByRef BitsInfo As DSBITMAPINFO, ByVal wUsage As Integer) As Integer

    'W[ϐ
    Private mGrpInfo As DSUSelectCameraDialog.VIDEOCAPTUREGRAPHINFO
    Private mVMR As IVMRMixerBitmap9    'VMR9tB^pC^[tF[X
    Private mBitmap As Bitmap           'ebvXVprbg}bv

    'j[FJINbN
    Private Sub MenuItem_CameraSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem_CameraSelect.Click

        'NA
        Timer_Update.Enabled = False
        mGrpInfo.Release()

        'JI_CAO\
        Dim dlg As New DSUSelectCameraDialog
        If dlg.ShowDialog(mGrpInfo) <> Windows.Forms.DialogResult.OK Then Exit Sub

        'VMR9_Otɒǉ
        Dim vmrflt As IBaseFilter = AddFilter(mGrpInfo.Graph, DSConst.FilterGUID.CLSID_VideoMixingRenderer9)

        'IVMRMixerBitmap9C^[tF[X擾
        mVMR = CType(vmrflt, IVMRMixerBitmap9)

        'Ot
        mGrpInfo.Graph.Render(mGrpInfo.Pin)

        'TCY擾
        Dim sz As Size = GetVideoSize(mGrpInfo.Graph)

        'rbg}bv
        mBitmap = New Bitmap(sz.Width, sz.Height, Imaging.PixelFormat.Format32bppArgb)
        Pic_Telop.Image = New Bitmap(sz.Width, sz.Height)

        'tH[TCY
        Pnl_View.Size = sz
        Pic_Telop.Size = sz
        Pic_Telop.Left = sz.Width
        Me.ClientSize = New Size(sz.Width * 2, sz.Height + MenuStrip_Main.Height)

        'plŏcۂčĐ悤ɐݒ
        SetVideoRendererOwner(mGrpInfo.Graph, Pnl_View, RendererScale.KeepAspect)

        'ĐJn
        GraphPlay(mGrpInfo.Graph)

        'ebvXV
        CreateTelopImage()
        UpdateTelop()

        '^C}[Jn
        Timer_Update.Enabled = True

    End Sub

    'tH[N[Y
    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'Ot̔j
        mGrpInfo.Release()

    End Sub

    '----------------------------------------------------------

    'ebvXVp^C}[Cxg
    Private Sub Timer_Update_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_Update.Tick

        'ԃ`FbN
        If mVMR Is Nothing Then Exit Sub

        'ebvXV
        CreateTelopImage()
        UpdateTelop()

    End Sub

    'ebv摜쐬
    Private Sub CreateTelopImage()

        '`Jn
        Dim g As Graphics = Graphics.FromImage(Pic_Telop.Image)

        'NA
        g.Clear(Color.Black)

        'AiOv`
        Dim pn As Pen = New Pen(Color.White, 3)
        Dim sz As Double = Math.Min(Pic_Telop.Width, Pic_Telop.Height) / 2
        For r As Double = 0 To 11
            g.DrawLine(pn, GetNeedlePoint(r / 12, sz), GetNeedlePoint(r / 12, sz * 0.95))   'g
        Next
        pn.Width = 7
        g.DrawLine(pn, GetNeedlePoint(0, 0), GetNeedlePoint(Now.Hour / 12, sz * 0.6))       'Zj
        pn.Width = 5
        g.DrawLine(pn, GetNeedlePoint(0, 0), GetNeedlePoint(Now.Minute / 60, sz * 0.8))     'j
        pn.Width = 1
        g.DrawLine(pn, GetNeedlePoint(0, 0), GetNeedlePoint(Now.Second / 60, sz * 0.8))     'bj

        '`I
        g.Dispose()
        Pic_Telop.Refresh()

    End Sub

    'AiOvj̈ʒuvZ(`p)
    Private Function GetNeedlePoint(ByVal Rot As Double, ByVal Scale As Double) As Point
        Dim pnt As Point
        pnt.X = CInt(Pic_Telop.Width / 2 + Scale * Math.Cos((Rot + 0.75) * 2 * Math.PI))
        pnt.Y = CInt(Pic_Telop.Height / 2 + Scale * Math.Sin((Rot + 0.75) * 2 * Math.PI))
        Return pnt
    End Function

    'ebv̍XV
    Private Sub UpdateTelop()

        '[NpC[W̍XV
        Dim g As Graphics = Graphics.FromImage(mBitmap)
        Dim DC As IntPtr = g.GetHdc

        'ebvpC[WbN
        Dim bmp As Bitmap = CType(Pic_Telop.Image, Bitmap)
        Dim rct As New Rectangle(0, 0, bmp.Width, bmp.Height)
        Dim bd As New System.Drawing.Imaging.BitmapData
        bmp.LockBits(rct, Imaging.ImageLockMode.ReadWrite, Imaging.PixelFormat.Format32bppArgb, bd)

        'ebvpC[W[NpC[WɃRs[
        Dim bi As DSBITMAPINFO
        With bi.BMPHeader
            .Size = System.Runtime.InteropServices.Marshal.SizeOf(bi.BMPHeader)
            .Width = bmp.Width
            .Height = -bmp.Height
            .Planes = 1
            .BitCount = 32
        End With
        SetDIBitsToDevice(DC, 0, 0, bmp.Width, bmp.Height, 0, 0, 0, bmp.Height, bd.Scan0, bi, 0)

        'ebvpC[W̃bN
        bmp.UnlockBits(bd)

        'VMR̐ݒ
        Dim vab As New VMR9AlphaBitmap
        With vab

            'tO(C[WhDCŎwBJ[L[Lj
            .dwFlags = VMR9AlphaBitmapFlags.VMR9AlphaBitmap_hDC Or VMR9AlphaBitmapFlags.VMR9AlphaBitmap_SrcColorKey

            'C[Wi[ĂfoCXReLXg
            .hDC = DC

            ']C[W͈(S)
            .rSrc.Left = 0
            .rSrc.Top = 0
            .rSrc.Right = mBitmap.Width
            .rSrc.Bottom = mBitmap.Height

            ']͈(S)
            .rDest.Left = 0
            .rDest.Top = 0
            .rDest.Right = 1
            .rDest.Bottom = 1

            'At@uhZx(0:SA1:Ss)
            .fAlpha = 0.8

            'J[L[
            .clrSrcKey = Color.Black.ToArgb

        End With
        mVMR.SetAlphaBitmap(vab)

        '[NpC[W̍XVI
        g.ReleaseHdc(DC)

    End Sub

End Class
